package com.proliferay.demo.controller;

import java.util.Map;

import javax.portlet.ActionRequest;
import javax.portlet.ActionResponse;
import javax.portlet.RenderRequest;
import javax.portlet.RenderResponse;

import org.springframework.stereotype.Controller;
import org.springframework.ui.Model;
import org.springframework.web.bind.annotation.ModelAttribute;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.portlet.bind.annotation.ActionMapping;
import org.springframework.web.portlet.bind.annotation.RenderMapping;

import com.liferay.portal.kernel.log.Log;
import com.liferay.portal.kernel.log.LogFactoryUtil;
import com.proliferay.demo.model.Customer;

/**
 * 
 * @author Hamidul Islam
 * 
 */
@Controller("helloWorldController")
@RequestMapping(value = "VIEW")
public class CustomerController {

	private Log log = LogFactoryUtil.getLog(CustomerController.class.getName());

	/**
	 * 
	 * When the portlet is added to the portal page this method will be called.
	 * So this is the default render method
	 */
	@RenderMapping
	public String viewHomePage(RenderRequest request, RenderResponse response) {

		log.info("#################Calling viewHomePage############");

		return "view";

	}

	@RenderMapping(params = "action=showForm")
	public String viewByParameter(Map<String, Object> map) {
		log.info("##############Calling viewByParameter###########");

		Customer customer = new Customer();

		/**
		 * Keep the object customer in the map this object will be used in the
		 * JSP as modelAttribute
		 */
		map.put("customer", customer);

		/**
		 * Returning a String "form"
		 *  This means that form.jsp is the view
		 */
		return "form";

	}

	@RenderMapping(params = "action=success")
	public String viewSuccess() {

		log.info("#############Calling viewSuccess###########");
		/**
		 * Display success.jsp
		 */
		return "success";

	}

	@ActionMapping(value = "handleCustomer")
	public void getCustomerData(
			@ModelAttribute("customer") Customer customer,
			ActionRequest actionRequest, ActionResponse actionResponse,
			Model model) {

		log.info("#############Calling getCustomerData##########");

		actionResponse.setRenderParameter("action", "success");

		model.addAttribute("successModel", customer);
	}

}
